#include "helper.h"

static bool is_csv_of_digits(const char *flag) {
  unsigned char *p = (unsigned char*)flag;

  while (*p) {
    if (*p!=' ' && !isdigit(*p) && *p!=',') {
      LOG(LL_ERROR, ("Flag value '%s' invalid CSV of digits at pos %d: use only digits, ' ' and ','", flag, (int) ((char*)p-(char*)flag)));
      return false;
    }
    p++;
  }
  return true;
}

bool is_button_flag_valid(const char *flag) {
  return is_csv_of_digits(flag);
}

bool is_relay_flag_valid(const char *flag) {
  return is_csv_of_digits(flag);
}
